/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __EXTRACT_H__
#define __EXTRACT_H__

struct s_archive;
struct s_dico;

int restore_obj_hardlink(struct s_archive *ai, char *fullpath, char *relpath, char *destdir, struct s_dico *d, int objtype, int fsid);
int restore_obj_symlink(struct s_archive *ai, char *fullpath, char *relpath, char *destdir, struct s_dico *d, int objtype, int fsid);
int restore_obj_devfile(struct s_archive *ai, char *fullpath, char *relpath, char *destdir, struct s_dico *d, int objtype, int fsid);
int restore_obj_regfile_unique(struct s_archive *ai, char *fullpath, char *relpath, char *destdir, struct s_dico *d, int objtype, int fsid);
int restore_obj_regfile_multi(struct s_archive *ai, char *destdir, struct s_dico *d, int objtype, int fsid);
int restore_object(struct s_archive *ai, int *errors, char *destdir, struct s_dico *dicoattr, u16 fsid);
int filesystem_extract(struct s_archive *ai, struct s_dico *dicofs, struct s_dico *dicocmdline, u16 fsid);
int extract_read_objects(struct s_archive *ai, int *errors, char *destdir, u16 fsid);
int read_mainhead(struct s_archive *ai, struct s_dico **dicomainhead);
int do_extract(char *archive, char *cmdargv[], int oper);
int restore_attr_std(u32 objtype, char *fullpath, char *relpath, struct s_dico *dicoattr);
int restore_attr_xattr(u32 objtype, char *fullpath, char *relpath, struct s_dico *dicoattr);
int restore_attr_windows(u32 objtype, char *fullpath, char *relpath, struct s_dico *dicoattr);
int listing_print_file(int fsid, int objtype, char *relpath);
int restore_attr_everything(int objtype, char *fullpath, char *relpath, struct s_dico *dicoattr);

#endif // __EXTRACT_H__
